#include <Servo.h> // include the servo

Servo sensServo; 

int servoPin = 5; // define digitalpin 5 for the servo

int motor1 = 10; // define the pins for the H-bridge
int motor1rev = 11;
int motor2 = 6;
int motor2rev = 9;

int sensor = 0; // define the sensor on analogPin 0


int led = 8; // define the LED on digitalpin 8
int Sensval; // the value from the sensor

int turnDelay = 600; // how long time to turn
const int stopDist = 300; // the dist to stop the robot
int servoDelay = 700; // stop the servo so the sensor can read


void setup()
{
  pinMode(motor1, OUTPUT); // set the motors as an output
  pinMode(motor1rev, OUTPUT);
  pinMode(motor2, OUTPUT);
  pinMode(motor2rev, OUTPUT);
  
  pinMode(led, OUTPUT); // set the LED as an output
  
  pinMode(sensor, INPUT); // set the sensor as an input
  
  Serial.begin(9600); // open the serial monitor
  
  sensServo.attach(servoPin); // attach the servo
  sensServo.write(95); // servo goes to the center
  
  Serial.println("start"); // write start
}

void loop() // main program
{
  Sensval = analogRead(sensor); // read val from the sensor
  
  if(Sensval > stopDist) // robot coming to a wall
  {
    look(); // look for the best way
  }
  
  else if(Sensval > 500) // robot to close
  {
    backup(700); // go backwards for 700ms
  }
  
  else // no danger
  {
    drive(); // just drive
  }
}
  
  

void stay() // robot stop
{
  digitalWrite(led, HIGH); // LED on
  digitalWrite(motor1, LOW);
  digitalWrite(motor1rev, LOW);
  digitalWrite(motor2, LOW);
  digitalWrite(motor2rev, LOW);
  delay(500);
  return;
}


void drive() // go forwards
{
  digitalWrite(led, LOW); // LED off
  digitalWrite(motor1, HIGH);
  digitalWrite(motor1rev, LOW);
  digitalWrite(motor2, HIGH);
  digitalWrite(motor2rev, LOW);
  Serial.println(Sensval);
  return;
}

void backup(int time) // go backwards
{
  digitalWrite(led, LOW); // LED off
  digitalWrite(motor1, LOW);
  digitalWrite(motor1rev, HIGH);
  digitalWrite(motor2, LOW);
  digitalWrite(motor2rev, HIGH);
  delay(time); // delay for the turn
}

void turnL() // turn left
{
  digitalWrite(led, LOW); // LED off
  digitalWrite(motor1, LOW);
  digitalWrite(motor1rev, HIGH);
  digitalWrite(motor2, HIGH);
  digitalWrite(motor2rev, LOW);
  delay(turnDelay); // how long the robot will turn
  sensServo.write(95); // servo goes to the center
}

void turnR() // turn right
{
  digitalWrite(led, LOW); // LED off
  digitalWrite(motor1, HIGH);
  digitalWrite(motor1rev, LOW);
  digitalWrite(motor2, LOW);
  digitalWrite(motor2rev, HIGH);
  delay(turnDelay); // how long the robot will turn
  sensServo.write(95);
}

void servoL() { // turn the servo to the left

  for(int pos = 95; pos>=30; pos-=1)
  {
    sensServo.write(pos);
    delay(5);
  }
}

void servoR() { // turn the servo to the right

  for(int pos = 95; pos < 160; pos += 1)  
  {
    sensServo.write(pos);
    delay(5);
  }
}   

void look() // what the robot will do if it comes to a wall
{
  stay(); // stop the robot
  
  servoL(); // turn the servo to left
  delay(servoDelay); // wait a bit
  int leftDist = analogRead(sensor); // read the dist from the wall on the left
  Serial.println(leftDist);
  Serial.print("   Left Dist");
  sensServo.write(95); // servo goes to the center
  
  servoR(); // turn the servo to right
  delay(servoDelay); // wait a bit
  int rightDist = analogRead(sensor); // read the dist from the wall on the right
  Serial.println(rightDist);
  Serial.print("   Right Dist");
  sensServo.write(95); // servo goes to center
  stay();
  
  if(leftDist < rightDist) // if left value is lower
  {
    turnL(); // then turn to left
    Serial.println("Left");
  }
  
  else 
  {
    turnR(); // else go to the right
    Serial.println("Right");
  }
  return;
}
 
